;;;======================================================
;;;     Lunochod V 1.0.1
;;;     EXECUTOR-NEXT Module
;;;     For ECLIPS Version 6.3
;;;     2016.12.04 Victor Kazarinov
;;;======================================================
;;;    .
;;;======================================================

(defmodule EXECUTOR-NEXT (import MAIN deftemplate ?ALL) (import MAIN deffunction ?ALL) (import MAIN defglobal ?ALL) (import SOLVER deftemplate ?ALL))

(defrule EXECUTOR-NEXT::Position-Next
 ?c <- (cycle ?current-cycle)
 ?t <- (agent-position-next (agent-name ?agent-name) (posx ?srcX) (posy ?srcY))
  =>
 (retract ?t)
 (assert (agent-position (agent-name ?agent-name) (posx ?srcX) (posy ?srcY)))
)

(defrule EXECUTOR-NEXT::Direction-Next
 ?c <- (cycle ?current-cycle)
 ?t <- (agent-direction-next (agent-name ?agent-name) (direction ?direction))
  =>
 (retract ?t)
 (assert (agent-direction (agent-name ?agent-name) (direction ?direction)))
)

(defrule EXECUTOR-NEXT::Image-Next
 ?c <- (cycle ?current-cycle)
 ?t <- (agent-image-next (agent-name ?agent-name) (sym ?sym) (color ?color))
  =>
 (retract ?t)
 (assert (agent-image (agent-name ?agent-name) (sym ?sym) (color ?color)))
)
