;;;======================================================
;;;     Lunochod V 1.0.1
;;;     MAIN Module
;;;     For ECLIPS Version 6.3
;;;     2016.12.02 Victor Kazarinov
;;;======================================================
;;;   .
;;;======================================================

;    ,    cycle,    
(deffacts MAIN::cycle-start
 (cycle -1)                                     ;    
)

;;;======================================================

(defrule MAIN::Cycle-Start
 (cycle -1)
  =>
 (tui-color-set ?*statuslineForeColor* ?*statuslineBackColor*)
 (tui-cls)
 (tui-cursor-set 0)
 (tui_status-print "MAIN::Program Lunochod started" 3)
)

(defrule MAIN::Cycle-Next                       ; ,     .
 ?f <- (cycle ?current-cycle)
  =>
 (retract ?f)
 (tui-xy-goto 0 ?*statusline0YPos*)
 (sys-delay 500)
 (bind ?next-cycle (+ ?current-cycle 1))
 (assert (cycle ?next-cycle))
 (focus SIMULATOR MISSION SENSOR SOLVER EXECUTOR EXECUTOR-NEXT)
)


(defrule MAIN::Cycle-End
 (declare (salience 99))
 ?f <- (cycle 30)
  =>
 (retract ?f)
 
 (tui-color-set ?*statuslineForeColor* ?*statuslineBackColor*)
 (tui-cursor-set 1)
 (if (> ?*gamefieldref* 0)
  then
   (sys-object-free ?*gamefieldref*)
 )
 (tui_status-print "" 3)
 (halt)
)