;;;======================================================
;;;     Lunochod V 1.0.1
;;;     SIMULATOR Module
;;;     For ECLIPS Version 6.3
;;;     2016.12.02 Victor Kazarinov
;;;======================================================
;;;    ,   .
;;;======================================================

(defmodule SIMULATOR (export deftemplate ?ALL) (import MAIN deftemplate ?ALL) (import MAIN deffunction ?ALL) (import MAIN defglobal ?ALL))


(defrule SIMULATOR::Mission1-Lunochod1-Start                  ;   1
 ?c <- (cycle 0)
  =>
 (bind ?*gamefieldref* (sys-2darray-create ?*gamefieldDimX* ?*gamefieldDimY* 1 1 ?*backgroundSym*)) ;     2020 .
 (field-fill ?*gamefieldDimX* ?*gamefieldDimY* 1 ?*gamefieldref*)
 
 ;   lunochod1
 (assert (agent-position (agent-name lunochod1) (posx 10) (posy 9)))
 (assert (agent-direction (agent-name lunochod1) (direction right)))
 (assert (agent-image (agent-name lunochod1) (sym 26) (color 10)))
 (assert (mission-phase (agent-name lunochod1) (mission-name mission1) (phase forward1))) ;   .
 (agent-goto 26 10 9 10 9 10 ?*backgroundSymBackColor*)

 (agent-goto ?*barrierSym* 24 10 28 13 15 ?*backgroundSymBackColor*)             ;     lunochod2. 
 ;(tui_status-print "SIMULATOR::Mission1:Start." 0)
)

(defrule SIMULATOR::Mission1-Lunochod2-Start                  ;   1
 ?c <- (cycle 3)
  =>
 ;   lunochod2
 (assert (agent-position (agent-name lunochod2) (posx 20) (posy 10)))
 (assert (agent-direction (agent-name lunochod2) (direction right)))
 (assert (agent-image (agent-name lunochod2) (sym 26) (color 14)))
 (assert (mission-phase (agent-name lunochod2) (mission-name mission1) (phase forward1))) ;   .
 (agent-goto 26 20 10 20 10 14 ?*backgroundSymBackColor*)
)


